=== debian/changelog ===
adaptixc2 (0.0~git20260120.3d608a9-0kali1) kali-dev; urgency=medium

  * Initial release

 -- Daniel Ruiz de Alegria <daniruiz@kali.org>  Thu, 22 Jan 2026 11:13:19 +0100
