=== AdaptixClient/CMakeLists.txt ===
--- 
+++ 
@@ -134,6 +134,7 @@
         Headers/Workers/SocksHandshakeWorker.h
         Headers/UI/Widgets/TerminalContainerWidget.h
         Headers/Workers/TerminalWorker.h
+        Headers/Workers/BuildWorker.h
         Headers/UI/Dialogs/DialogDownloader.h
         Headers/Workers/DownloaderWorker.h
         Headers/Workers/UploaderWorker.h
@@ -156,6 +157,7 @@
         Headers/UI/Widgets/ChatWidget.h
         Headers/UI/Widgets/AbstractDock.h
         Headers/Utils/NonBlockingDialogs.h
+        Headers/UI/Dialogs/DialogSubscriptions.h
         Headers/Utils/FontManager.h
         Headers/Utils/TitleBarStyle.h
         Headers/UI/Widgets/DockWidgetRegister.h
@@ -175,6 +177,7 @@
 
         Source/Utils/Logs.cpp
         Source/UI/Dialogs/DialogConnect.cpp
+        Source/UI/Dialogs/DialogSubscriptions.cpp
         Source/Utils/Convert.cpp
         Source/MainAdaptix.cpp
         Source/Client/Storage.cpp
@@ -220,6 +223,7 @@
         Source/Workers/SocksHandshakeWorker.cpp
         Source/UI/Widgets/TerminalContainerWidget.cpp
         Source/Workers/TerminalWorker.cpp
+        Source/Workers/BuildWorker.cpp
         Source/UI/Dialogs/DialogDownloader.cpp
         Source/Workers/DownloaderWorker.cpp
         Source/Workers/UploaderWorker.cpp
