=== debian/changelog ===
adaptixc2 (1.1~git20260208.6605760-0kali1) kali-dev; urgency=medium

  * New upstream version 1.1~git20260208.6605760
  * Use absolute paths in profile config

 -- Daniel Ruiz de Alegría <daniruiz@kali.org>  Fri, 13 Feb 2026 11:54:18 +0100
