=== debian/control ===
Source: adaptixc2
Section: net
Priority: optional
Maintainer: Kali Developers <devel@kali.org>
Uploaders: Daniel Ruiz de Alegría <daniruiz@kali.org>
Rules-Requires-Root: no
Build-Depends:
 ca-certificates,
 cmake,
 debhelper-compat (= 13),
 dh-golang,
 g++-mingw-w64,
 golang-any,
 libssl-dev,
 libxkbcommon-dev,
 mingw-w64,
 qt6-base-dev,
 qt6-base-private-dev,
 qt6-declarative-dev,
 qt6-websockets-dev,
Standards-Version: 4.7.3
Homepage: https://github.com/Adaptix-Framework/AdaptixC2
Vcs-Browser: https://gitlab.com/kalilinux/packages/adaptixc2
Vcs-Git: https://gitlab.com/kalilinux/packages/adaptixc2.git
XS-Go-Import-Path: github.com/Adaptix-Framework/Adaptix-Framework

Package: adaptixc2
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: extensible post-exploitation and adversarial emulation framework
 Adaptix is an extensible post-exploitation and adversarial emulation framework
 made for authorized penetration testing. The Adaptix server is written in
 Golang and to allow operator flexibility.
