=== debian/rules ===
#!/usr/bin/make -f

export GOCACHE=$(CURDIR)/vendor
export GOPATH=$(CURDIR)/vendor
export GOTOOLCHAIN=auto

%:
	dh $@ --buildsystem=golang

override_dh_auto_build:
	make

override_dh_auto_install:
	dh_auto_install -- --no-source

override_dh_auto_test:
