=== debian/tests/control ===
Test-Command: adaptixserver -h
Restrictions: superficial, allow-stderr
