=== debian/watch ===
Version: 5

Source: https://github.com/Adaptix-Framework/AdaptixC2
Matching-Pattern: HEAD
Mode: git
